<?php

/**
 * Implementation of hook views_default_views().
 */
function cforge_yell_views_default_views() {
  $view = mc_directory_user_view();
  $views[$view->name] = $view;

  $view = yell_directory_view(0);
  $views[$view->name] = $view;
  if (variable_get('offers_wants_proposition_wants', TRUE)) {
    $view = yell_directory_view(1);
    $views[$view->name] = $view;
  }
  return $views;
}


function yell_directory_view($want) {
  $view = new view;
  $view->name = $want ? 'ow_wants' : 'ow_offers';
  $view->description = $want ? t('Directory of wants') : t('Directory of offers');
  $view->description .= ' ('. t('Default view is autogenerated') . ')';
  $view->tag = 'offers_wants';
  $view->base_table = 'node';
  $view->human_name = $want ? 'Auto wants view' : 'Auto offers view';
  $view->core = 0;
  $view->api_version = '3.0';
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */

  /* Display: Defaults */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $handler->display->display_options['title'] = $want ? t('Wants') : t('Offers');
  $handler->display->display_options['use_more'] = TRUE;
  $handler->display->display_options['use_more_always'] = FALSE;
  $handler->display->display_options['use_more_text'] = 'more';
  $handler->display->display_options['access']['type'] = 'perm';
  $handler->display->display_options['access']['perm'] = 'access content';
  $handler->display->display_options['cache']['type'] = 'none';
  $handler->display->display_options['query']['options']['disable_sql_rewrite'] = TRUE;
  $handler->display->display_options['query']['options']['distinct'] = TRUE;
  $handler->display->display_options['query']['options']['query_comment'] = FALSE;
  $handler->display->display_options['exposed_form']['type'] = 'basic';
  $handler->display->display_options['pager']['type'] = 'full';
  $handler->display->display_options['pager']['options']['items_per_page'] = '25';
  $handler->display->display_options['pager']['options']['offset'] = '0';
  $handler->display->display_options['pager']['options']['id'] = '0';
  $handler->display->display_options['style_plugin'] = 'table';
  $handler->display->display_options['style_options']['columns'] = array(
    'image' => 'image',
    'title' => 'title',
    'body' => 'body',
    'name' => 'name',
    'picture' => 'picture',
    'profile_address_dependent_locality' => 'profile_address_dependent_locality',
    'end' => 'end',
  );
  $handler->display->display_options['style_options']['default'] = '-1';
  $handler->display->display_options['style_options']['info'] = array(
    'image' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'title' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'body' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'picture' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'profile_address_dependent_locality' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'end' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );
  $handler->display->display_options['defaults']['style_options'] = FALSE;
  /* Comportement en l'absence de résultats: Global : Zone de texte */
  $handler->display->display_options['empty']['text']['id'] = 'area';
  $handler->display->display_options['empty']['text']['table'] = 'views';
  $handler->display->display_options['empty']['text']['field'] = 'area';
  $handler->display->display_options['empty']['text']['content'] = $want ? 'No wants have been entered.' : 'No offers have been entered.';
  $handler->display->display_options['empty']['text']['format'] = 'plain_text';

  $handler->display->display_options['defaults']['row_plugin'] = FALSE;
  $handler->display->display_options['defaults']['row_options'] = FALSE;
  $handler->display->display_options['defaults']['fields'] = FALSE;
  /* Relation: Content : Auteur */
  $handler->display->display_options['relationships']['uid']['id'] = 'uid';
  $handler->display->display_options['relationships']['uid']['table'] = 'node';
  $handler->display->display_options['relationships']['uid']['field'] = 'uid';
  /* Relationship: Content: Offer/want types (offers_wants_types) */
  $handler->display->display_options['relationships']['offers_wants_types_tid']['id'] = 'offers_wants_types_tid';
  $handler->display->display_options['relationships']['offers_wants_types_tid']['table'] = 'field_data_offers_wants_types';
  $handler->display->display_options['relationships']['offers_wants_types_tid']['field'] = 'offers_wants_types_tid';
  /* Relationship: Field: Offer/want categories (offers_wants_categories) */
  $handler->display->display_options['relationships']['offers_wants_categories_tid_1']['id'] = 'offers_wants_categories_tid_1';
  $handler->display->display_options['relationships']['offers_wants_categories_tid_1']['table'] = 'field_data_offers_wants_categories';
  $handler->display->display_options['relationships']['offers_wants_categories_tid_1']['field'] = 'offers_wants_categories_tid';
  /* Field: Content : Image */
  $handler->display->display_options['fields']['image']['id'] = 'image';
  $handler->display->display_options['fields']['image']['table'] = 'field_data_image';
  $handler->display->display_options['fields']['image']['field'] = 'image';
  $handler->display->display_options['fields']['image']['click_sort_column'] = 'fid';
  $handler->display->display_options['fields']['image']['settings'] = array(
    'image_style' => 'thumbnail',
    'image_link' => '',
  );
  /* Field: Content : title */
  $handler->display->display_options['fields']['title']['id'] = 'title';
  $handler->display->display_options['fields']['title']['table'] = 'node';
  $handler->display->display_options['fields']['title']['field'] = 'title';
  $handler->display->display_options['fields']['title']['label'] = 'Description';
  /* Field: Content : Corps */
  $handler->display->display_options['fields']['body']['id'] = 'body';
  $handler->display->display_options['fields']['body']['table'] = 'field_data_body';
  $handler->display->display_options['fields']['body']['field'] = 'body';
  $handler->display->display_options['fields']['body']['label'] = '';
  $handler->display->display_options['fields']['body']['type'] = 'text_summary_or_trimmed';
  $handler->display->display_options['fields']['body']['settings'] = array(
    'trim_length' => '600',
  );
  /* Field: Propositions : Expiry date */
  $handler->display->display_options['fields']['end']['id'] = 'end';
  $handler->display->display_options['fields']['end']['table'] = 'offers_wants';
  $handler->display->display_options['fields']['end']['field'] = 'end';
  $handler->display->display_options['fields']['end']['label'] = 'Expires on';
  $handler->display->display_options['fields']['end']['date_format'] = 'short';
  /* Field: User : Nom */
  $handler->display->display_options['fields']['name']['id'] = 'name';
  $handler->display->display_options['fields']['name']['table'] = 'users';
  $handler->display->display_options['fields']['name']['field'] = 'name';
  $handler->display->display_options['fields']['name']['relationship'] = 'uid';
  $handler->display->display_options['fields']['name']['label'] = 'Member';
  /* Field: User : Image */
  $handler->display->display_options['fields']['picture']['id'] = 'picture';
  $handler->display->display_options['fields']['picture']['table'] = 'users';
  $handler->display->display_options['fields']['picture']['field'] = 'picture';
  $handler->display->display_options['fields']['picture']['relationship'] = 'uid';
  $handler->display->display_options['fields']['picture']['label'] = '';
  $handler->display->display_options['fields']['picture']['image_style'] = 'thumbnail';
  /* Field: User : Localité */
  $handler->display->display_options['fields']['profile_address_dependent_locality']['id'] = 'profile_address_dependent_locality';
  $handler->display->display_options['fields']['profile_address_dependent_locality']['table'] = 'field_data_profile_address';
  $handler->display->display_options['fields']['profile_address_dependent_locality']['field'] = 'profile_address_dependent_locality';
  $handler->display->display_options['fields']['profile_address_dependent_locality']['relationship'] = 'uid';
  $handler->display->display_options['defaults']['filter_groups'] = FALSE;
  $handler->display->display_options['defaults']['filters'] = FALSE;
  /* Filter: Content : Type */
  $handler->display->display_options['filters']['type']['id'] = 'type';
  $handler->display->display_options['filters']['type']['table'] = 'node';
  $handler->display->display_options['filters']['type']['field'] = 'type';
  $handler->display->display_options['filters']['type']['value'] = array(
    'proposition' => 'proposition',
  );
  $handler->display->display_options['filters']['type']['expose']['operator'] = FALSE;
  /* Filter: Propositions : Is a want*/
  $handler->display->display_options['filters']['want']['id'] = 'want';
  $handler->display->display_options['filters']['want']['table'] = 'offers_wants';
  $handler->display->display_options['filters']['want']['field'] = 'want';
  $handler->display->display_options['filters']['want']['value'] = $want;
  /* Filter: User : Actif */
  $handler->display->display_options['filters']['status']['id'] = 'status';
  $handler->display->display_options['filters']['status']['table'] = 'users';
  $handler->display->display_options['filters']['status']['field'] = 'status';
  $handler->display->display_options['filters']['status']['relationship'] = 'uid';
  $handler->display->display_options['filters']['status']['value'] = '1';
  $handler->display->display_options['filters']['status']['expose']['operator'] = FALSE;

  /* Filter: Content : Node status (Published) */
  $handler->display->display_options['filters']['status_1']['id'] = 'status_1';
  $handler->display->display_options['filters']['status_1']['table'] = 'node';
  $handler->display->display_options['filters']['status_1']['field'] = 'status';
  $handler->display->display_options['filters']['status_1']['value'] = '1';
  /* Sort criterion: Content: Updated date */
  $handler->display->display_options['sorts']['changed']['id'] = 'changed';
  $handler->display->display_options['sorts']['changed']['table'] = 'node';
  $handler->display->display_options['sorts']['changed']['field'] = 'changed';
  $handler->display->display_options['sorts']['changed']['order'] = 'DESC';
  $handler->display->display_options['sorts']['changed']['granularity'] = 'hour';
  /* Contextual filter: Content: Has taxonomy term ID */
  $handler->display->display_options['arguments']['term_node_tid_depth']['id'] = 'term_node_tid_depth';
  $handler->display->display_options['arguments']['term_node_tid_depth']['table'] = 'node';
  $handler->display->display_options['arguments']['term_node_tid_depth']['field'] = 'term_node_tid_depth';
  $handler->display->display_options['arguments']['term_node_tid_depth']['exception']['title'] = 'All';
  $handler->display->display_options['arguments']['term_node_tid_depth']['title_enable'] = TRUE;
  $handler->display->display_options['arguments']['term_node_tid_depth']['title'] = $want ? 'Wants %1' : 'Offers %1';
  $handler->display->display_options['arguments']['term_node_tid_depth']['default_argument_type'] = 'fixed';
  $handler->display->display_options['arguments']['term_node_tid_depth']['summary']['number_of_records'] = '0';
  $handler->display->display_options['arguments']['term_node_tid_depth']['summary']['format'] = 'default_summary';
  $handler->display->display_options['arguments']['term_node_tid_depth']['summary_options']['items_per_page'] = '25';
  $handler->display->display_options['arguments']['term_node_tid_depth']['depth'] = '1';
  /* Filtre contextuel: Terme de taxonomie : Identifiant (ID) du terme */
  $handler->display->display_options['arguments']['tid']['id'] = 'tid';
  $handler->display->display_options['arguments']['tid']['table'] = 'taxonomy_term_data';
  $handler->display->display_options['arguments']['tid']['field'] = 'tid';
  $handler->display->display_options['arguments']['tid']['relationship'] = 'offers_wants_types_tid';
  $handler->display->display_options['arguments']['tid']['exception']['title'] = 'Tout';
  $handler->display->display_options['arguments']['tid']['default_argument_type'] = 'fixed';
  $handler->display->display_options['arguments']['tid']['summary']['number_of_records'] = '0';
  $handler->display->display_options['arguments']['tid']['summary']['format'] = 'default_summary';
  $handler->display->display_options['arguments']['tid']['summary_options']['items_per_page'] = '25';
  $handler->display->display_options['arguments']['tid']['specify_validation'] = TRUE;
  $handler->display->display_options['arguments']['tid']['validate']['type'] = 'taxonomy_term';
  $handler->display->display_options['arguments']['tid']['validate_options']['vocabularies'] = array(
    'offers_wants_types' => 'offers_wants_types',
  );

  /* Display: All */
  $handler = $view->new_display('page', 'All', 'all');
  $handler->display->display_options['defaults']['title'] = FALSE;
  $handler->display->display_options['title'] = $want ? 'Wants' : 'Offers';
  $handler->display->display_options['defaults']['hide_admin_links'] = FALSE;
  $handler->display->display_options['defaults']['style_plugin'] = FALSE;
  $handler->display->display_options['style_plugin'] = 'table';
  $handler->display->display_options['style_options']['columns'] = array(
    'image' => 'image',
    'title' => 'title',
    'name' => 'name',
    'offers_wants_categories' => 'offers_wants_categories',
    'end' => 'end',
    'profile_address_dependent_locality_1' => 'profile_address_dependent_locality_1',
    'status' => 'status',
  );
  $handler->display->display_options['style_options']['default'] = '-1';
  $handler->display->display_options['style_options']['info'] = array(
    'image' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 1,
    ),
    'title' => array(
      'sortable' => 0,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'name' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'offers_wants_categories' => array(
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'end' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'profile_address_dependent_locality_1' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
    'status' => array(
      'sortable' => 1,
      'default_sort_order' => 'asc',
      'align' => '',
      'separator' => '',
      'empty_column' => 0,
    ),
  );
  $handler->display->display_options['defaults']['style_options'] = FALSE;
  $handler->display->display_options['defaults']['row_plugin'] = FALSE;
  $handler->display->display_options['defaults']['row_options'] = FALSE;
  $handler->display->display_options['defaults']['fields'] = FALSE;
  /* Field: Content : Image */
  $handler->display->display_options['fields']['image']['id'] = 'image';
  $handler->display->display_options['fields']['image']['table'] = 'field_data_image';
  $handler->display->display_options['fields']['image']['field'] = 'image';
  $handler->display->display_options['fields']['image']['click_sort_column'] = 'fid';
  $handler->display->display_options['fields']['image']['settings'] = array(
    'image_style' => 'thumbnail',
    'image_link' => '',
  );
  /* Field: Content : title */
  $handler->display->display_options['fields']['title']['id'] = 'title';
  $handler->display->display_options['fields']['title']['table'] = 'node';
  $handler->display->display_options['fields']['title']['field'] = 'title';
  $handler->display->display_options['fields']['title']['label'] = 'Description';
  $handler->display->display_options['fields']['title']['element_label_colon'] = FALSE;
  /* Field: Field : offers_wants_categories */
  $handler->display->display_options['fields']['offers_wants_categories']['id'] = 'offers_wants_categories';
  $handler->display->display_options['fields']['offers_wants_categories']['table'] = 'field_data_offers_wants_categories';
  $handler->display->display_options['fields']['offers_wants_categories']['field'] = 'offers_wants_categories';
  $handler->display->display_options['fields']['offers_wants_categories']['label'] = 'Categories';
  $handler->display->display_options['fields']['offers_wants_categories']['delta_offset'] = '0';
  /* Field: Propositions : Expiry date */
  $handler->display->display_options['fields']['end']['id'] = 'end';
  $handler->display->display_options['fields']['end']['table'] = 'offers_wants';
  $handler->display->display_options['fields']['end']['field'] = 'end';
  $handler->display->display_options['fields']['end']['label'] = 'Expires on';
  $handler->display->display_options['fields']['end']['date_format'] = 'short';
  /* Field: User : Nom */
  $handler->display->display_options['fields']['name']['id'] = 'name';
  $handler->display->display_options['fields']['name']['table'] = 'users';
  $handler->display->display_options['fields']['name']['field'] = 'name';
  $handler->display->display_options['fields']['name']['relationship'] = 'uid';
  $handler->display->display_options['fields']['name']['label'] = 'Member';
  $handler->display->display_options['fields']['name']['element_label_colon'] = FALSE;
  /* Field: User : Neighbourhood */
  //this assumes the addressfield module is present with user profile field called 'profile_address'
  $handler->display->display_options['fields']['profile_address_dependent_locality_1']['id'] = 'profile_address_dependent_locality_1';
  $handler->display->display_options['fields']['profile_address_dependent_locality_1']['table'] = 'field_data_profile_address';
  $handler->display->display_options['fields']['profile_address_dependent_locality_1']['field'] = 'profile_address_dependent_locality';
  $handler->display->display_options['fields']['profile_address_dependent_locality_1']['relationship'] = 'uid';
  /* Field: Content : Node status */
  $handler->display->display_options['fields']['status']['id'] = 'status';
  $handler->display->display_options['fields']['status']['table'] = 'node';
  $handler->display->display_options['fields']['status']['field'] = 'status';
  $handler->display->display_options['fields']['status']['type'] = 'unicode-yes-no';
  $handler->display->display_options['fields']['status']['not'] = 0;

  $handler->display->display_options['path'] = $want ? 'wants/all' : 'offers/all';
  $handler->display->display_options['menu']['type'] = 'default tab';
  $handler->display->display_options['menu']['title'] = 'All';
  $handler->display->display_options['menu']['weight'] = '0';
  $handler->display->display_options['tab_options']['type'] = 'normal';
  $handler->display->display_options['tab_options']['title'] = $want ? 'Wants' : 'Offers';
  $handler->display->display_options['tab_options']['weight'] = 3;
  $handler->display->display_options['tab_options']['name'] = 'main-menu';
  

  if ($want) {
    /* Display: Demandes urgentes */
    $handler = $view->new_display('block', t('Urgent wants'), 'urgent');
    $handler->display->display_options['defaults']['title'] = FALSE;
    $handler->display->display_options['title'] = 'Upcoming needs';
    $handler->display->display_options['block_description'] = 'Upcoming needs';
    $handler->display->display_options['display_description'] = '';
    $handler->display->display_options['defaults']['hide_admin_links'] = FALSE;
    $handler->display->display_options['defaults']['use_more'] = FALSE;
    $handler->display->display_options['use_more'] = TRUE;
    $handler->display->display_options['defaults']['pager'] = FALSE;
    $handler->display->display_options['pager']['type'] = 'some';
    $handler->display->display_options['pager']['options']['items_per_page'] = '5';
    $handler->display->display_options['pager']['options']['offset'] = '0';
    $handler->display->display_options['defaults']['style_plugin'] = FALSE;
    $handler->display->display_options['style_plugin'] = 'list';
    $handler->display->display_options['defaults']['style_options'] = FALSE;
    $handler->display->display_options['defaults']['row_plugin'] = FALSE;
    $handler->display->display_options['row_plugin'] = 'fields';
    $handler->display->display_options['row_options']['inline'] = array(
      'title' => 'title',
      'name' => 'name',
      'end' => 'end',
    );
    $handler->display->display_options['defaults']['row_options'] = FALSE;
    $handler->display->display_options['defaults']['fields'] = FALSE;
    /* Field: Content : title */
    $handler->display->display_options['fields']['title']['id'] = 'title';
    $handler->display->display_options['fields']['title']['table'] = 'node';
    $handler->display->display_options['fields']['title']['field'] = 'title';
    $handler->display->display_options['fields']['title']['label'] = '';
    $handler->display->display_options['fields']['title']['exclude'] = TRUE;
    $handler->display->display_options['fields']['title']['element_label_colon'] = FALSE;
    $handler->display->display_options['fields']['title']['hide_alter_empty'] = FALSE;
    /* Field: User : Name */
    $handler->display->display_options['fields']['name']['id'] = 'name';
    $handler->display->display_options['fields']['name']['table'] = 'users';
    $handler->display->display_options['fields']['name']['field'] = 'name';
    $handler->display->display_options['fields']['name']['relationship'] = 'uid';
    $handler->display->display_options['fields']['name']['label'] = '';
    $handler->display->display_options['fields']['name']['exclude'] = TRUE;
    $handler->display->display_options['fields']['name']['alter']['alter_text'] = TRUE;
    $handler->display->display_options['fields']['name']['alter']['text'] = '- [name]';
    $handler->display->display_options['fields']['name']['element_label_colon'] = FALSE;
    $handler->display->display_options['fields']['name']['hide_alter_empty'] = FALSE;
    /* Field: Propositions : Expiry date */
    $handler->display->display_options['fields']['end']['id'] = 'end';
    $handler->display->display_options['fields']['end']['table'] = 'offers_wants';
    $handler->display->display_options['fields']['end']['field'] = 'end';
    $handler->display->display_options['fields']['end']['label'] = '';
    $handler->display->display_options['fields']['end']['alter']['alter_text'] = TRUE;
    $handler->display->display_options['fields']['end']['alter']['text'] = '[name] needs [title] before [end]';
    $handler->display->display_options['fields']['end']['element_label_colon'] = FALSE;
    $handler->display->display_options['fields']['end']['date_format'] = 'raw time hence';
    $handler->display->display_options['defaults']['sorts'] = FALSE;
    /* Sort: Propositions : Expiry date */
    $handler->display->display_options['sorts']['end']['id'] = 'end';
    $handler->display->display_options['sorts']['end']['table'] = 'offers_wants';
    $handler->display->display_options['sorts']['end']['field'] = 'end';
    $handler->display->display_options['defaults']['filter_groups'] = FALSE;
    $handler->display->display_options['defaults']['filters'] = FALSE;
    /* Filter: Content : Type */
    $handler->display->display_options['filters']['type']['id'] = 'type';
    $handler->display->display_options['filters']['type']['table'] = 'node';
    $handler->display->display_options['filters']['type']['field'] = 'type';
    $handler->display->display_options['filters']['type']['value'] = array(
      'proposition' => 'proposition',
    );
    /* Filter: Propositions : Expiry date */
    $handler->display->display_options['filters']['end']['id'] = 'end';
    $handler->display->display_options['filters']['end']['table'] = 'offers_wants';
    $handler->display->display_options['filters']['end']['field'] = 'end';
    $handler->display->display_options['filters']['end']['operator'] = '>';
    $handler->display->display_options['filters']['end']['value']['value'] = '-1 day';
    $handler->display->display_options['filters']['end']['value']['type'] = 'offset';
    /* Filter: Propositions : is a want */
    $handler->display->display_options['filters']['want']['id'] = 'want';
    $handler->display->display_options['filters']['want']['table'] = 'offers_wants';
    $handler->display->display_options['filters']['want']['field'] = 'want';
    $handler->display->display_options['filters']['want']['value'] = '1';
    /* Filter: User : user status (active) */
    $handler->display->display_options['filters']['status']['id'] = 'status';
    $handler->display->display_options['filters']['status']['table'] = 'users';
    $handler->display->display_options['filters']['status']['field'] = 'status';
    $handler->display->display_options['filters']['status']['relationship'] = 'uid';
    $handler->display->display_options['filters']['status']['value'] = '1';
    /* Filter: Content : Node status (Published) */
    $handler->display->display_options['filters']['status_1']['id'] = 'status_1';
    $handler->display->display_options['filters']['status_1']['table'] = 'node';
    $handler->display->display_options['filters']['status_1']['field'] = 'status';
    $handler->display->display_options['filters']['status_1']['value'] = '1';
    $handler->display->display_options['block_description'] = 'Upcoming needs';
  }

  /* Display: latest offers/wants */
  $handler = $view->new_display('block', $want ? t('Latest wants') : t('Latest offers'), 'latest');
  $handler->display->display_options['defaults']['title'] = FALSE;
  $handler->display->display_options['title'] = $want ? t('Latest wants') : t('Latest offers');
  $handler->display->display_options['style_plugin'] = 'list';
  $handler->display->display_options['defaults']['style_options'] = FALSE;
  $handler->display->display_options['defaults']['row_plugin'] = FALSE;
  $handler->display->display_options['defaults']['style_plugin'] = FALSE;
  $handler->display->display_options['defaults']['pager'] = FALSE;
  $handler->display->display_options['defaults']['use_more'] = FALSE;
  $handler->display->display_options['use_more'] = TRUE;
  $handler->display->display_options['pager']['type'] = 'some';
  $handler->display->display_options['pager']['options']['items_per_page'] = '5';
  $handler->display->display_options['pager']['options']['offset'] = '0';
  $handler->display->display_options['defaults']['row_options'] = FALSE;
  $handler->display->display_options['defaults']['fields'] = FALSE;
  $handler->display->display_options['row_plugin'] = 'fields';
  $handler->display->display_options['row_options']['inline'] = array(
    'title' => 'title',
    'name' => 'name',
  );
  $handler->display->display_options['row_options']['hide_empty'] = 0;
  $handler->display->display_options['row_options']['default_field_elements'] = 1;
  /* Field: Content: Title */
  $handler->display->display_options['fields']['title']['id'] = 'title';
  $handler->display->display_options['fields']['title']['table'] = 'node';
  $handler->display->display_options['fields']['title']['field'] = 'title';
  $handler->display->display_options['fields']['title']['label'] = '';
  $handler->display->display_options['fields']['title']['element_label_colon'] = FALSE;
  $handler->display->display_options['fields']['title']['element_default_classes'] = 1;
  $handler->display->display_options['fields']['title']['hide_empty'] = 0;
  $handler->display->display_options['fields']['title']['empty_zero'] = 0;
  $handler->display->display_options['fields']['title']['hide_alter_empty'] = 0;
  $handler->display->display_options['fields']['title']['link_to_node'] = 1;
  /* Field: User: Name */
  $handler->display->display_options['fields']['name']['id'] = 'name';
  $handler->display->display_options['fields']['name']['table'] = 'users';
  $handler->display->display_options['fields']['name']['field'] = 'name';
  $handler->display->display_options['fields']['name']['relationship'] = 'uid';
  $handler->display->display_options['fields']['name']['label'] = '';
  $handler->display->display_options['fields']['name']['alter']['alter_text'] = 1;
  $handler->display->display_options['fields']['name']['alter']['text'] = '- [name]';
  $handler->display->display_options['fields']['name']['element_label_colon'] = FALSE;
  $handler->display->display_options['fields']['name']['element_default_classes'] = 1;
  $handler->display->display_options['fields']['name']['hide_empty'] = 0;
  $handler->display->display_options['fields']['name']['empty_zero'] = 0;
  $handler->display->display_options['fields']['name']['hide_alter_empty'] = 0;
  $handler->display->display_options['fields']['name']['link_to_user'] = 1;
  $handler->display->display_options['fields']['name']['overwrite_anonymous'] = 0;
  $handler->display->display_options['block_description'] = $want ? t('Latest wants') : t('Latest offers');


  /* Display: CSV Data export */
  $handler = $view->new_display('views_data_export', 'Export to CSV', 'views_data_export_1');
  $handler->display->display_options['defaults']['hide_admin_links'] = FALSE;
  $handler->display->display_options['defaults']['access'] = FALSE;
  $handler->display->display_options['access']['type'] = 'perm';
  $handler->display->display_options['access']['perm'] = 'post proposition';
  $handler->display->display_options['pager']['type'] = 'none';
  $handler->display->display_options['pager']['options']['offset'] = '0';
  $handler->display->display_options['style_plugin'] = 'views_data_export_csv';
  $handler->display->display_options['style_options']['provide_file'] = 1;
  $handler->display->display_options['style_options']['filename'] = $want ? 'wants.csv' : 'offers.csv';
  $handler->display->display_options['style_options']['parent_sort'] = 0;
  $handler->display->display_options['style_options']['quote'] = 1;
  $handler->display->display_options['style_options']['trim'] = 0;
  $handler->display->display_options['style_options']['replace_newlines'] = 1;
  $handler->display->display_options['style_options']['newline_replacement'] = '\\n';
  $handler->display->display_options['style_options']['header'] = 1;
  $handler->display->display_options['use_batch'] = 'batch';
  $handler->display->display_options['path'] = $want ? 'wants.csv' : 'offers.csv';
  $handler->display->display_options['displays'] = array('all' => 'all');

  //get all the terms in the types vocab and add a display for each.
  $tids = _yell_type_tids();
  if (count($tids) > 1) {
    foreach($tids as $tid) {
      _yell_views_add_proptype($view, $tid, $want);
    }
    //sort out the tabs for the proptype menu items
  }
  return $view;
}

function _yell_type_tids() {
  return db_query("SELECT tid FROM {taxonomy_term_data} d LEFT JOIN {taxonomy_vocabulary} v ON v.vid = d.vid WHERE v.machine_name = :name",
    array(':name' => 'offers_wants_types')
  )->fetchCol();
}

/*
 * add a display for each of the terms in the proptypes vocab
 * inherits most things from the default display
 */
function _yell_views_add_proptype(&$view, $tid, $want) {
  $term = taxonomy_term_load($tid);
  $handler = $view->new_display('page', $term->name, 'tab-'.$term->tid);
  $handler->display->display_options['defaults']['title'] = FALSE;
  $handler->display->display_options['title'] = $term->name;
  $handler->display->display_options['defaults']['filters'] = FALSE;
  /* Filter criterion: Content: Type */
  $handler->display->display_options['filters']['type']['id'] = 'type';
  $handler->display->display_options['filters']['type']['table'] = 'node';
  $handler->display->display_options['filters']['type']['field'] = 'type';
  $handler->display->display_options['filters']['type']['value'] = array(
      'proposition' => 'proposition',
  );
  $handler->display->display_options['filters']['type']['expose']['operator'] = FALSE;
  /* Filter criterion: Content: Published or admin */
  $handler->display->display_options['filters']['status_extra']['id'] = 'status_extra';
  $handler->display->display_options['filters']['status_extra']['table'] = 'node';
  $handler->display->display_options['filters']['status_extra']['field'] = 'status_extra';
  /* Filter criterion: User: Active */
  $handler->display->display_options['filters']['status']['id'] = 'status';
  $handler->display->display_options['filters']['status']['table'] = 'users';
  $handler->display->display_options['filters']['status']['field'] = 'status';
  $handler->display->display_options['filters']['status']['relationship'] = 'uid';
  $handler->display->display_options['filters']['status']['value'] = '1';
  $handler->display->display_options['filters']['status']['expose']['operator'] = FALSE;
  /* Filter criterion: Propositions: Is a want */
  $handler->display->display_options['filters']['want']['id'] = 'want';
  $handler->display->display_options['filters']['want']['table'] = 'offers_wants';
  $handler->display->display_options['filters']['want']['field'] = 'want';
  $handler->display->display_options['filters']['want']['value'] = $want;
  /* Filter criterion: Content: Offer/want types (offers_wants_types) */
  $handler->display->display_options['filters']['field_proptypes_tid']['id'] = 'offers_wants_types_tid';
  $handler->display->display_options['filters']['field_proptypes_tid']['table'] = 'field_data_offers_wants_types';
  $handler->display->display_options['filters']['field_proptypes_tid']['field'] = 'offers_wants_types_tid';
  $handler->display->display_options['filters']['field_proptypes_tid']['value'] = array( 0 => $tid);
  $handler->display->display_options['filters']['field_proptypes_tid']['type'] = 'select';
  $handler->display->display_options['filters']['field_proptypes_tid']['vocabulary'] = 'offers_wants_types';
  /* page display settings */
  $handler->display->display_options['path'] = ($want ? 'wants/' : 'offers/') . $tid;
  $handler->display->display_options['menu']['type'] = 'tab';
  $handler->display->display_options['menu']['title'] = $term->name;
  $handler->display->display_options['menu']['weight'] = $term->weight;
}
